<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html xmlns:v="urn:schemas-microsoft-com:vml"
 xmlns:o="urn:schemas-microsoft-com:office:office"
 xmlns:w="urn:schemas-microsoft-com:office:word"
 xmlns="http://www.w3.org/TR/REC-html40">
<head>
  <meta http-equiv="Content-Type"
 content="text/html; charset=windows-1252">
  <meta name="ProgId" content="FrontPage.Editor.Document">
  <meta name="Generator" content="Microsoft FrontPage 4.0">
  <meta name="Originator" content="Microsoft Word 9">
  <link rel="File-List" href="./EsComp_files/filelist.xml">
  <link rel="Edit-Time-Data" href="./EsComp_files/editdata.mso">
<!--[if !mso]>
<style>
v\:* {behavior:url(#default#VML);}
o\:* {behavior:url(#default#VML);}
w\:* {behavior:url(#default#VML);}
.shape {behavior:url(#default#VML);}
</style>
<![endif]-->
  <title>Esempio di Compitino</title>
<!--[if gte mso 9]><xml>
 <o:DocumentProperties>
  <o:Author>susanna</o:Author>
  <o:Template>Normal</o:Template>
  <o:LastAuthor>giorgio</o:LastAuthor>
  <o:Revision>2</o:Revision>
  <o:TotalTime>0</o:TotalTime>
  <o:LastPrinted>2003-05-28T17:19:00Z</o:LastPrinted>
  <o:Created>2003-10-28T09:17:00Z</o:Created>
  <o:LastSaved>2003-10-28T09:17:00Z</o:LastSaved>
  <o:Pages>5</o:Pages>
  <o:Words>1259</o:Words>
  <o:Characters>7177</o:Characters>
  <o:Lines>59</o:Lines>
  <o:Paragraphs>14</o:Paragraphs>
  <o:CharactersWithSpaces>8813</o:CharactersWithSpaces>
  <o:Version>9.3821</o:Version>
 </o:DocumentProperties>
</xml><![endif]--><!--[if gte mso 9]><xml>
 <w:WordDocument>
  <w:DrawingGridHorizontalSpacing>0 pt</w:DrawingGridHorizontalSpacing>
  <w:DrawingGridVerticalSpacing>0 pt</w:DrawingGridVerticalSpacing>
  <w:DisplayHorizontalDrawingGridEvery>0</w:DisplayHorizontalDrawingGridEvery>
  <w:DisplayVerticalDrawingGridEvery>0</w:DisplayVerticalDrawingGridEvery>
  <w:UseMarginsForDrawingGridOrigin/>
  <w:DrawingGridHorizontalOrigin>0 pt</w:DrawingGridHorizontalOrigin>
  <w:DrawingGridVerticalOrigin>0 pt</w:DrawingGridVerticalOrigin>
  <w:Compatibility>
   <w:FootnoteLayoutLikeWW8/>
   <w:ShapeLayoutLikeWW8/>
   <w:AlignTablesRowByRow/>
   <w:ForgetLastTabAlignment/>
   <w:LayoutRawTableWidth/>
   <w:LayoutTableRowsApart/>
  </w:Compatibility>
 </w:WordDocument>
</xml><![endif]-->
  <style>
<!--
 /* Font Definitions */
@font-face
	{font-family:Helvetica;
	panose-1:2 11 6 4 2 2 2 2 2 4;
	mso-font-charset:0;
	mso-generic-font-family:swiss;
	mso-font-format:other;
	mso-font-pitch:variable;
	mso-font-signature:3 0 0 0 1 0;}
@font-face
	{font-family:Courier;
	panose-1:0 0 0 0 0 0 0 0 0 0;
	mso-font-alt:"Courier New";
	mso-font-charset:0;
	mso-generic-font-family:modern;
	mso-font-format:other;
	mso-font-pitch:fixed;
	mso-font-signature:3 0 0 0 1 0;}
@font-face
	{font-family:Wingdings;
	panose-1:5 0 0 0 0 0 0 0 0 0;
	mso-font-charset:2;
	mso-generic-font-family:auto;
	mso-font-pitch:variable;
	mso-font-signature:0 268435456 0 0 -2147483648 0;}
@font-face
	{font-family:Tahoma;
	panose-1:2 11 6 4 3 5 4 4 2 4;
	mso-font-charset:0;
	mso-generic-font-family:swiss;
	mso-font-pitch:variable;
	mso-font-signature:553679495 -2147483648 8 0 66047 0;}
@font-face
	{font-family:StarBats;
	panose-1:0 0 4 0 0 0 0 0 0 0;
	mso-font-charset:2;
	mso-generic-font-family:auto;
	mso-font-pitch:variable;
	mso-font-signature:0 268435456 0 0 -2147483648 0;}
 /* Style Definitions */
p.MsoNormal, li.MsoNormal, div.MsoNormal
	{mso-style-parent:"";
	margin:0cm;
	margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
h1
	{mso-style-next:Normal;
	margin-top:12.0pt;
	margin-right:0cm;
	margin-bottom:3.0pt;
	margin-left:0cm;
	text-indent:0cm;
	mso-pagination:widow-orphan;
	page-break-after:avoid;
	mso-outline-level:1;
	mso-list:l4 level1 lfo5;
	mso-hyphenate:none;
	font-size:14.0pt;
	mso-bidi-font-size:10.0pt;
	font-family:Arial;
	mso-bidi-font-family:"Times New Roman";
	mso-font-kerning:25088.5pt;
	mso-ansi-language:IT;
	mso-fareast-language:IT;
	mso-bidi-font-weight:normal;}
h2
	{mso-style-next:Normal;
	margin-top:12.0pt;
	margin-right:0cm;
	margin-bottom:3.0pt;
	margin-left:0cm;
	text-indent:0cm;
	mso-pagination:widow-orphan;
	page-break-after:avoid;
	mso-outline-level:2;
	mso-list:l4 level2 lfo5;
	mso-hyphenate:none;
	font-size:12.0pt;
	mso-bidi-font-size:10.0pt;
	font-family:Arial;
	mso-bidi-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;
	mso-bidi-font-weight:normal;
	font-style:italic;
	mso-bidi-font-style:normal;}
h3
	{mso-style-next:Normal;
	margin-top:12.0pt;
	margin-right:0cm;
	margin-bottom:3.0pt;
	margin-left:0cm;
	text-indent:0cm;
	mso-pagination:widow-orphan;
	page-break-after:avoid;
	mso-outline-level:3;
	mso-list:l4 level3 lfo5;
	mso-hyphenate:none;
	font-size:12.0pt;
	mso-bidi-font-size:10.0pt;
	font-family:Arial;
	mso-bidi-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;
	font-weight:normal;}
h4
	{mso-style-next:Normal;
	margin:0cm;
	margin-bottom:.0001pt;
	text-indent:0cm;
	mso-pagination:widow-orphan;
	page-break-after:avoid;
	mso-outline-level:4;
	mso-list:l4 level4 lfo5;
	mso-hyphenate:none;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;
	mso-bidi-font-weight:normal;}
h5
	{mso-style-next:Normal;
	margin:0cm;
	margin-bottom:.0001pt;
	text-indent:0cm;
	mso-pagination:widow-orphan;
	page-break-after:avoid;
	mso-outline-level:5;
	mso-list:l4 level5 lfo5;
	mso-hyphenate:none;
	border:none;
	mso-border-top-alt:solid black .1pt;
	padding:0cm;
	mso-padding-alt:1.0pt 0cm 0cm 0cm;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;
	mso-bidi-font-weight:normal;}
h6
	{mso-style-next:Normal;
	margin:0cm;
	margin-bottom:.0001pt;
	text-align:center;
	text-indent:0cm;
	mso-pagination:widow-orphan;
	page-break-after:avoid;
	mso-outline-level:6;
	mso-list:l4 level6 lfo5;
	mso-hyphenate:none;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;
	mso-bidi-font-weight:normal;}
p.MsoHeader, li.MsoHeader, div.MsoHeader
	{margin:0cm;
	margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	tab-stops:center 240.95pt right 481.9pt;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
p.MsoFooter, li.MsoFooter, div.MsoFooter
	{margin:0cm;
	margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	tab-stops:center 240.95pt right 481.9pt;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
p.MsoBodyText, li.MsoBodyText, div.MsoBodyText
	{margin-top:0cm;
	margin-right:0cm;
	margin-bottom:6.0pt;
	margin-left:0cm;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
span.WW-Caratterepredefinitoparagrafo
	{mso-style-name:"WW-Carattere predefinito paragrafo";
	mso-style-parent:"";}
span.WW8Num1z0
	{mso-style-name:WW8Num1z0;
	mso-style-parent:"";
	mso-ansi-font-size:9.0pt;
	mso-ascii-font-family:StarBats;
	mso-hansi-font-family:StarBats;}
span.WW8Num3z0
	{mso-style-name:WW8Num3z0;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num3z1
	{mso-style-name:WW8Num3z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num3z2
	{mso-style-name:WW8Num3z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num10z0
	{mso-style-name:WW8Num10z0;
	mso-style-parent:"";
	mso-ascii-font-family:"Times New Roman";
	mso-hansi-font-family:"Times New Roman";}
span.WW8Num10z1
	{mso-style-name:WW8Num10z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num10z2
	{mso-style-name:WW8Num10z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num10z3
	{mso-style-name:WW8Num10z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num11z0
	{mso-style-name:WW8Num11z0;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num11z1
	{mso-style-name:WW8Num11z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num11z2
	{mso-style-name:WW8Num11z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num12z0
	{mso-style-name:WW8Num12z0;
	mso-style-parent:"";
	mso-ansi-font-size:12.0pt;
	mso-ascii-font-family:Arial;
	mso-hansi-font-family:Arial;
	font-weight:bold;
	font-style:italic;}
span.WW8Num20z0
	{mso-style-name:WW8Num20z0;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num20z1
	{mso-style-name:WW8Num20z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num20z2
	{mso-style-name:WW8Num20z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num22z1
	{mso-style-name:WW8Num22z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num22z2
	{mso-style-name:WW8Num22z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num22z3
	{mso-style-name:WW8Num22z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num27z0
	{mso-style-name:WW8Num27z0;
	mso-style-parent:"";
	mso-ansi-font-size:12.0pt;
	mso-ascii-font-family:Arial;
	mso-hansi-font-family:Arial;
	font-weight:bold;
	font-style:italic;}
span.WW8Num31z0
	{mso-style-name:WW8Num31z0;
	mso-style-parent:"";
	mso-ascii-font-family:"Times New Roman";
	mso-hansi-font-family:"Times New Roman";}
span.WW8Num31z1
	{mso-style-name:WW8Num31z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num31z2
	{mso-style-name:WW8Num31z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num31z3
	{mso-style-name:WW8Num31z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num32z0
	{mso-style-name:WW8Num32z0;
	mso-style-parent:"";
	mso-ascii-font-family:"Times New Roman";
	mso-hansi-font-family:"Times New Roman";}
span.WW8Num32z1
	{mso-style-name:WW8Num32z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num32z2
	{mso-style-name:WW8Num32z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num32z3
	{mso-style-name:WW8Num32z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num33z0
	{mso-style-name:WW8Num33z0;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num35z0
	{mso-style-name:WW8Num35z0;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num39z0
	{mso-style-name:WW8Num39z0;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num39z1
	{mso-style-name:WW8Num39z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num39z3
	{mso-style-name:WW8Num39z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num44z0
	{mso-style-name:WW8Num44z0;
	mso-style-parent:"";
	mso-ascii-font-family:"Times New Roman";
	mso-hansi-font-family:"Times New Roman";}
span.WW8Num44z1
	{mso-style-name:WW8Num44z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num44z2
	{mso-style-name:WW8Num44z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num44z3
	{mso-style-name:WW8Num44z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num46z0
	{mso-style-name:WW8Num46z0;
	mso-style-parent:"";
	mso-ascii-font-family:"Times New Roman";
	mso-hansi-font-family:"Times New Roman";}
span.WW8Num46z1
	{mso-style-name:WW8Num46z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num46z2
	{mso-style-name:WW8Num46z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num46z3
	{mso-style-name:WW8Num46z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num48z0
	{mso-style-name:WW8Num48z0;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num48z1
	{mso-style-name:WW8Num48z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num48z3
	{mso-style-name:WW8Num48z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num49z0
	{mso-style-name:WW8Num49z0;
	mso-style-parent:"";
	mso-ascii-font-family:"Times New Roman";
	mso-hansi-font-family:"Times New Roman";}
span.WW8Num49z1
	{mso-style-name:WW8Num49z1;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
span.WW8Num49z2
	{mso-style-name:WW8Num49z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num49z3
	{mso-style-name:WW8Num49z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num50z0
	{mso-style-name:WW8Num50z0;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num52z2
	{mso-style-name:WW8Num52z2;
	mso-style-parent:"";
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
span.WW8Num52z3
	{mso-style-name:WW8Num52z3;
	mso-style-parent:"";
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
span.WW8Num52z4
	{mso-style-name:WW8Num52z4;
	mso-style-parent:"";
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
p.Heading, li.Heading, div.Heading
	{mso-style-name:Heading;
	mso-style-next:"Body Text";
	margin-top:12.0pt;
	margin-right:0cm;
	margin-bottom:6.0pt;
	margin-left:0cm;
	mso-pagination:widow-orphan;
	page-break-after:avoid;
	mso-hyphenate:none;
	font-size:14.0pt;
	mso-bidi-font-size:10.0pt;
	font-family:Helvetica;
	mso-fareast-font-family:"Times New Roman";
	mso-bidi-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
p.WW-Mappadocumento, li.WW-Mappadocumento, div.WW-Mappadocumento
	{mso-style-name:"WW-Mappa documento";
	margin:0cm;
	margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	background:navy;
	font-size:10.0pt;
	font-family:Tahoma;
	mso-fareast-font-family:"Times New Roman";
	mso-bidi-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
p.WW-Corpodeltesto2, li.WW-Corpodeltesto2, div.WW-Corpodeltesto2
	{mso-style-name:"WW-Corpo del testo 2";
	margin:0cm;
	margin-bottom:.0001pt;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	border:none;
	mso-border-top-alt:solid black .1pt;
	padding:0cm;
	mso-padding-alt:1.0pt 0cm 0cm 0cm;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
p.Framecontents, li.Framecontents, div.Framecontents
	{mso-style-name:"Frame contents";
	mso-style-parent:"Body Text";
	margin-top:0cm;
	margin-right:0cm;
	margin-bottom:6.0pt;
	margin-left:0cm;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
p.TableContents, li.TableContents, div.TableContents
	{mso-style-name:"Table Contents";
	mso-style-parent:"Body Text";
	margin-top:0cm;
	margin-right:0cm;
	margin-bottom:6.0pt;
	margin-left:0cm;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;}
p.TableHeading, li.TableHeading, div.TableHeading
	{mso-style-name:"Table Heading";
	mso-style-parent:"Table Contents";
	margin-top:0cm;
	margin-right:0cm;
	margin-bottom:6.0pt;
	margin-left:0cm;
	text-align:center;
	mso-pagination:widow-orphan;
	mso-hyphenate:none;
	font-size:10.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";
	mso-ansi-language:IT;
	mso-fareast-language:IT;
	font-weight:bold;
	mso-bidi-font-weight:normal;
	font-style:italic;
	mso-bidi-font-style:normal;}
 /* Page Definitions */
@page
	{mso-footnote-position:beneath-text;}
@page Section1
	{size:595.25pt 841.85pt;
	margin:2.0cm 1.0cm 46.7pt 1.0cm;
	mso-header-margin:35.45pt;
	mso-footer-margin:35.45pt;
	mso-header:url("./EsComp_files/header.htm") h1;
	mso-footer:url("./EsComp_files/header.htm") f1;
	mso-paper-source:0;}
div.Section1
	{page:Section1;}
 /* List Definitions */
@list l0
	{mso-list-id:1;
	mso-list-template-ids:1;
	mso-list-name:WW8Num22;}
@list l0:level1
	{mso-level-suffix:none;
	mso-level-text:%1-;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l0:level2
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:o;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
@list l0:level3
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
@list l0:level4
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0B7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
@list l0:level5
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:o;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
@list l0:level6
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
@list l0:level7
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0B7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
@list l0:level8
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:o;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
@list l0:level9
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
@list l1
	{mso-list-id:2;
	mso-list-template-ids:2;
	mso-list-name:WW8Num23;}
@list l1:level1
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-text:"%1\)";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l1:level2
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l1:level3
	{mso-level-number-format:roman-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:right;
	text-indent:-9.0pt;}
@list l1:level4
	{mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l1:level5
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l1:level6
	{mso-level-number-format:roman-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:right;
	text-indent:-9.0pt;}
@list l1:level7
	{mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l1:level8
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l1:level9
	{mso-level-number-format:roman-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:right;
	text-indent:-9.0pt;}
@list l2
	{mso-list-id:3;
	mso-list-template-ids:3;
	mso-list-name:WW8Num30;}
@list l2:level1
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-text:"%1\)";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l2:level2
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l2:level3
	{mso-level-number-format:roman-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:right;
	text-indent:-9.0pt;}
@list l2:level4
	{mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l2:level5
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l2:level6
	{mso-level-number-format:roman-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:right;
	text-indent:-9.0pt;}
@list l2:level7
	{mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l2:level8
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l2:level9
	{mso-level-number-format:roman-lower;
	mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:right;
	text-indent:-9.0pt;}
@list l3
	{mso-list-id:4;
	mso-list-template-ids:4;
	mso-list-name:WW8Num52;}
@list l3:level1
	{mso-level-suffix:none;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l3:level2
	{mso-level-number-format:alpha-lower;
	mso-level-suffix:none;
	mso-level-text:"%2\)";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l3:level3
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
@list l3:level4
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0B7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
@list l3:level5
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:o;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
@list l3:level6
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
@list l3:level7
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0B7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
@list l3:level8
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:o;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
@list l3:level9
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
@list l4
	{mso-list-id:5;
	mso-list-template-ids:5;}
@list l4:level1
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l4:level2
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l4:level3
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l4:level4
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l4:level5
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l4:level6
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l4:level7
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l4:level8
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l4:level9
	{mso-level-number-format:none;
	mso-level-suffix:none;
	mso-level-text:"";
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	margin-left:0cm;
	text-indent:0cm;}
@list l5
	{mso-list-id:524295613;
	mso-list-type:simple;
	mso-list-template-ids:224036286;}
@list l5:level1
	{mso-level-start-at:3;
	mso-level-text:%1;
	mso-level-tab-stop:18.0pt;
	mso-level-number-position:left;
	margin-left:18.0pt;
	text-indent:-18.0pt;
	mso-ansi-font-size:12.0pt;
	font-family:Arial;
	mso-bidi-font-family:"Times New Roman";
	mso-ansi-font-weight:bold;
	mso-ansi-font-style:italic;}
@list l6
	{mso-list-id:966668704;
	mso-list-type:simple;
	mso-list-template-ids:68157463;}
@list l6:level1
	{mso-level-number-format:alpha-lower;
	mso-level-text:"%1\)";
	mso-level-tab-stop:18.0pt;
	mso-level-number-position:left;
	margin-left:18.0pt;
	text-indent:-18.0pt;}
@list l7
	{mso-list-id:995378078;
	mso-list-type:hybrid;
	mso-list-template-ids:-1149729536;}
@list l7:level1
	{mso-level-text:"%1\)";
	mso-level-tab-stop:36.0pt;
	mso-level-number-position:left;
	text-indent:-18.0pt;}
@list l8
	{mso-list-id:1997492443;
	mso-list-type:hybrid;
	mso-list-template-ids:1646850248 -1472819058 68157443 68157445 68157441 68157443 68157445 68157441 68157443 68157445;}
@list l8:level1
	{mso-level-start-at:3;
	mso-level-number-format:bullet;
	mso-level-text:-;
	mso-level-tab-stop:36.0pt;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	font-family:"Times New Roman";
	mso-fareast-font-family:"Times New Roman";}
@list l9
	{mso-list-id:2105152303;
	mso-list-template-ids:-2048900754;}
@list l9:level1
	{mso-level-text:%1-;
	mso-level-tab-stop:18.0pt;
	mso-level-number-position:left;
	margin-left:18.0pt;
	text-indent:-18.0pt;}
@list l9:level2
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:o;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
@list l9:level3
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
@list l9:level4
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0B7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
@list l9:level5
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:o;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
@list l9:level6
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
@list l9:level7
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0B7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Symbol;
	mso-hansi-font-family:Symbol;}
@list l9:level8
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:o;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:"Courier New";
	mso-hansi-font-family:"Courier New";}
@list l9:level9
	{mso-level-number-format:bullet;
	mso-level-suffix:none;
	mso-level-text:\F0A7;
	mso-level-tab-stop:none;
	mso-level-number-position:left;
	text-indent:-18.0pt;
	mso-ascii-font-family:Wingdings;
	mso-hansi-font-family:Wingdings;}
ol
	{margin-bottom:0cm;}
ul
	{margin-bottom:0cm;}
-->
  </style><!--[if gte mso 9]><xml>
 <o:shapedefaults v:ext="edit" spidmax="3074">
  <o:colormenu v:ext="edit" fillcolor="none" strokecolor="none [1]"
   shadowcolor="none [2]"/>
 </o:shapedefaults></xml><![endif]--><!--[if gte mso 9]><xml>
 <o:shapelayout v:ext="edit">
  <o:idmap v:ext="edit" data="2"/>
 </o:shapelayout></xml><![endif]-->
</head>
<body lang="EN-GB" style="color: rgb(0, 0, 0);" link="#0000ee"
 alink="#0000ee" vlink="#551a8b">
<div class="Section1"
 style="font-family: courier new,courier,monospace;">
<div
 style="border-style: solid none none; border-color: black -moz-use-text-color -moz-use-text-color; border-width: 0.1pt medium medium; padding: 1pt 0cm 0cm; font-weight: bold;"><big></big>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><big><big>Esempio
di
compitino</big></big></p>
</div>
<p class="MsoNormal" style="font-weight: bold;"><!--[endif]--><big><o:p></o:p></big></p>
<div
 style="border-style: solid none none; border-color: black -moz-use-text-color -moz-use-text-color; border-width: 0.1pt medium medium; padding: 1pt 0cm 0cm;"><big>
</big>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><big><span
 style="font-weight: bold;"><br>
Domanda 1: </span><br>
Elencare almeno 3
circostanze che possono causare la transizione di un processo da stato
di
bloccato a stato di pronto. Motivare la risposta. </big></p>
<big></big>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><!--[if !supportEmptyParas]--><big><br>
<span style="font-weight: bold;">Soluzione : </span><br>
Esecuzione di una
up() sul semaforo su cui il processo &egrave; bloccato, arrivo di una
interruzione da
un dispositivo che ha completato una richiesta, <br>
uscita di un processo da un
monitor su cui il processo &egrave; in attesa.<br>
</big></p>
<big></big></div>
<div
 style="border-style: solid none none; border-color: black -moz-use-text-color -moz-use-text-color; border-width: 0.1pt medium medium; padding: 1pt 0cm 0cm;"><big>
</big>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><big><br>
<span style="font-weight: bold;">Domanda 2:</span> <br>
</big></p>
<big></big>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><big>Discutere
la
differenza fra process table e user area in un sistema Unix. In quale
delle due strutture si trova l'immagine dei registri del processore? </big></p>
<big></big>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><!--[if !supportEmptyParas]--><big>&nbsp;<o:p></o:p></big><!--[endif]--></p>
<big></big></div>
<p class="MsoHeader" style=""><big><span style="font-weight: bold;">Soluzione:</span><o:p></o:p></big></p>
<p class="MsoHeader" style=""><big>La process table e la
user area raccologono le informazioni relative ai processi nei sistemi
Unix. La
differenza fondamentale &egrave; che la process table viene tenuta
sempre in
memoria
mentre la user area viene copiata su disco quando il processo &egrave;
&#8216;swapped out&#8217;.
Tipicamente la process table contiene: la signal mask, l&#8217;immagine della
memoria, il pid del processo e tutte le informazioni che servono anche
quando
il processo non pu&ograve; passare in esecuzione. Esempi di
informazioni
contenute
nella user area sono invece l&#8217;array dei gestori dei segnali, la tabella
dei
descrittori dei file, la kernel stack. </big></p>
<p class="MsoHeader" style=""><big>L&#8217;immagine dei
registri si trova nella user area.</big></p>
<p class="MsoNormal"><!--[if !supportEmptyParas]--><big>&nbsp;</big></p>
<div
 style="border-style: solid none none; border-color: windowtext -moz-use-text-color -moz-use-text-color; border-width: 0.5pt medium medium; padding: 1pt 0cm 0cm;"><big>
</big>
<div
 style="border-style: solid none none; border-color: black -moz-use-text-color -moz-use-text-color; border-width: 0.1pt medium medium; padding: 1pt 0cm 0cm;"><big></big>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><big><span
 style="font-weight: bold;">Esercizio 1</span>: <br>
Si consideri il
problema dei lettori e scrittori, con riferimento alla soluzione
proposta nel
testo e riportata di seguito: </big></p>
<big></big></div>
<big></big>
<p class="MsoNormal"><!--[if !supportEmptyParas]--><big>&nbsp;<o:p></o:p></big><!--[endif]--></p>
<big></big>
<p class="MsoHeader" style=""><big>semaphore mutex=1;<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style=""><big>semaphore db=1;<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style=""><big>int rc=0;<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style=""><!--[if !supportEmptyParas]--><big>&nbsp;<o:p></o:p></big><!--[endif]--></p>
<big></big>
<p class="MsoHeader" style=""><big>void reader (void) {<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>while (TRUE) {<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
down(&amp;mutex);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
rc=rc+1;<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader"
 style="text-indent: 35.4pt; background-color: rgb(255, 255, 0);"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
if (rc==1) down(&amp;db);&nbsp;&nbsp;&nbsp; (-2-)<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="margin-left: 35.4pt; text-indent: 35.4pt;"><big>up(&amp;mutex);
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
read_DataBase();<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
down(&amp;mutex);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
rc=rc-1;<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader"
 style="text-indent: 35.4pt; background-color: rgb(255, 255, 0);"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
if (rc==0) up(&amp;db);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
(-3-)<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="margin-left: 35.4pt; text-indent: 35.4pt;"><big>up(&amp;mutex);
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
use_data_read();<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>}<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style=""><big>}<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style=""><big>void writer(void) {<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style=""><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
while
(TRUE) {<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style=""><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Think_Up_Data();<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader"
 style="text-indent: 35.4pt; background-color: rgb(255, 255, 51);"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
down(&amp;db);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
(-0-)<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><!--[if !supportEmptyParas]--><big>&nbsp;<o:p></o:p></big><!--[endif]--></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
write_data_base();<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader"
 style="text-indent: 35.4pt; background-color: rgb(255, 255, 0);"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
up(&amp;db);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
(-1-)<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style="text-indent: 35.4pt;"><big>}<o:p></o:p></big></p>
<big></big>
<p class="MsoHeader" style=""><big>}<o:p></o:p></big></p>
<big></big>
<p class="MsoNormal"><!--[if !supportEmptyParas]--><big>&nbsp;<o:p></o:p></big><!--[endif]--></p>
<big></big>
<p class="MsoNormal"><big>Dire cosa accade se:</big></p>
<big></big>
<p class="MsoNormal" style="margin-left: 36pt; text-indent: -18pt;"><!--[if !supportLists]--><big>a)si
eliminano gli statement (-0-) e
(-1-)</big><!--[endif]--></p>
<big></big>
<p class="MsoNormal" style="margin-left: 36pt; text-indent: -18pt;"><!--[if !supportLists]--><!--[endif]--><big>b)si
elimina lo statement (-2-) </big></p>
<big></big>
<p class="MsoNormal" style="margin-left: 36pt; text-indent: -18pt;"><!--[if !supportLists]--><big>c)si
elimina lo statement (-3-)</big><!--[endif]--></p>
<big></big>
<p class="MsoNormal"><!--[if !supportEmptyParas]--><big>&nbsp;<o:p></o:p></big><!--[endif]--></p>
<big></big>
<p class="MsoNormal"><big><span style="font-weight: bold;">Soluzione:</span>
<o:p></o:p></big></p>
<big></big>
<p class="MsoNormal" style="margin-left: 18pt; text-indent: -18pt;"><!--[if !supportLists]--><big>a)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
si possono avere corse critiche (interferenze) fra i lettori e gli
scrittori e fra pi&ugrave; scrittori</big><!--[endif]--></p>
<big></big>
<p class="MsoNormal" style="margin-left: 18pt; text-indent: -18pt;"><!--[if !supportLists]--><big>b)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
i lettori possono accedere al database mentre uno scrittore lo sta
modificando</big><!--[endif]--></p>
<big></big>
<p class="MsoNormal" style="margin-left: 18pt; text-indent: -18pt;"><!--[if !supportLists]--><big>c)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
gli scrittori possono rimanere bloccati per sempre in attesa su &amp;db</big><!--[endif]--></p>
<big></big></div>
<p class="MsoNormal"><!--[endif]--><big><o:p></o:p></big></p>
<p class="MsoNormal"><big>&nbsp;</big></p>
<div
 style="border-style: solid none none; border-color: windowtext -moz-use-text-color -moz-use-text-color; border-width: 0.5pt medium medium; padding: 1pt 0cm 0cm;"><big>
</big>
<p class="MsoNormal"
 style="border: medium none ; padding: 0cm; font-weight: bold;"><big>Esercizio
2</big></p>
<big></big>
<p class="MsoNormal" style="border: medium none ; padding: 0cm;"><big>&nbsp;Supponiamo
di
ricevere 5 job (A,B,C,D,E)&nbsp; tali che:</big></p>
<big></big></div>
<p class="MsoNormal"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
job&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; Tempo
stimato &nbsp;&nbsp;&nbsp; Tempo di arrivo</big></p>
<p class="MsoNormal"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
A&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
26&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
0</big></p>
<p class="MsoNormal"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
B&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
60&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
1</big></p>
<p class="MsoNormal"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
C&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
2</big></p>
<p class="MsoNormal"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
D&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
8&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
3</big></p>
<p class="MsoNormal"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
E&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
10&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
4<br>
<br>
Descrivere la sequenza di esecuzione dei job in
CPU (ad es. tramite Gantt chart) e calcolare l'istante&nbsp;</big></p>
<p class="MsoNormal"><big>in cui ogni job completa il suo task e il
relativo tempo totale di completamento ottenuto con:</big></p>
<ol>
  <big> </big><li><big> </big>
    <p class="MsoNormal"><big>&nbsp;scheduling FIFO&nbsp;<br>
    </big></p>
    <big> </big></li>
  <big> </big><li><big> </big>
    <p class="MsoNormal"><big>&nbsp;scheduling round-robin con quanto
di
tempo 5<br>
    </big></p>
    <big> </big></li>
  <big> </big><li><big> </big>
    <p class="MsoNormal"><big>&nbsp;scheduling a code multiple di
priorita'
con quanto di tempo 5,<br>
&nbsp;considerando&nbsp; le seguenti priorit&agrave;:&nbsp; A: 3, B: 4,
C: 1,
D: 2, E: 2&nbsp; (4 pi&ugrave; alta) <br>
&nbsp;e supponendo che lo scheduler controlli le code&nbsp; e possa
prelazionare la CPU ogni secondo&nbsp; </big></p>
    <big> </big></li>
  <big></big>
</ol>
<p class="MsoNormal"><big>&nbsp;</big></p>
<p class="MsoNormal"><big> Si ignori il tempo impiegato nel
context-switching.</big></p>
<p class="MsoNormal"><!--[if !supportEmptyParas]--><big>&nbsp;<o:p></o:p></big><!--[endif]--></p>
<p class="MsoNormal"><big><span style="font-weight: bold;">Soluzione.</span><br>
<o:p></o:p></big></p>
<p class="MsoNormal"><big><br>
1. Viene prima eseguito A, quindi B, ecc.</big></p>
<p class="MsoNormal"><big>A partire dall&#8217;istante 0, l'istante di
completamento con scheduling FIFO &egrave;:</big></p>
<p class="MsoHeader" style=""><big><br>
Job A: 26&nbsp;&nbsp; (quindi tempo totale compl. = 26)<o:p></o:p></big></p>
<p class="MsoNormal"><big>Job B: 86&nbsp; (tc=85)<o:p></o:p></big></p>
<p class="MsoHeader" style=""><big>Job C: 91 (tc=89)<o:p></o:p></big></p>
<p class="MsoNormal"><big>Job D: 99 (tc=96)<o:p></o:p></big></p>
<p class="MsoNormal"><big>Job E: 109 (tc=105) </big></p>
<p class="MsoNormal"><!--[if !supportEmptyParas]--><big>&nbsp;<o:p></o:p></big><!--[endif]--></p>
<p class="MsoNormal"><big>2.&nbsp; A viene eseguito per 5 unit&agrave;,
B x 5, C x
5, D x 5, E x 5,
quindi nuovamente A x 5, B x 5, D x 3 (completato), E x 5 (completato),</big></p>
<p class="MsoNormal"><big>A x 5, B x 5, A x 5, B x 5, A x 5, B x 5, A x
1, B
x le
restanti 35 unit&agrave;.</big></p>
<p class="MsoNormal"><big>&nbsp;</big></p>
<p class="MsoNormal"><big>Quindi a partire dall&#8217;istante 0, l'istante di
completamento con scheduling Round Robin &egrave;:</big></p>
<p class="MsoHeader" style=""><big><br>
Job A: 74 (tc=...)<o:p></o:p></big></p>
<p class="MsoHeader" style=""><big>Job B: 109<o:p></o:p></big></p>
<p class="MsoHeader" style=""><big>Job C: 15 <o:p></o:p></big></p>
<p class="MsoNormal"><big>Job D: 38<o:p></o:p></big></p>
<p class="MsoNormal"><big>Job E: 43</big> </p>
<p class="MsoNormal">&nbsp;</p>
<p class="MsoNormal"><big>3.&nbsp; Usiamo Gantt chart<br>
</big></p>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 600px;">
  <big> </big><tbody>
    <big> </big><tr>
      <big> </big><td style="vertical-align: top;">Tempo&nbsp; <br>
      </td>
      <td style="vertical-align: top;">0-1<br>
(1unita)<br>
      </td>
      <td style="vertical-align: top;">1-61<br>
(12quanti)<br>
      </td>
      <td style="vertical-align: top;">61-86<br>
(5quanti)<br>
      </td>
      <td style="vertical-align: top;">86-91 <br>
(1quanto)<br>
      </td>
      <td style="vertical-align: top;">91-96<br>
(1quanto)</td>
      <td style="vertical-align: top;">96-99<br>
(3unita)<br>
      </td>
      <td style="vertical-align: top;">99-104<br>
(1quanto)<br>
      </td>
      <td style="vertical-align: top;">104-109<br>
(1quanto)<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">Job in <br>
CPU<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">B</td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">D<br>
      </td>
      <td style="vertical-align: top;">E<br>
      </td>
      <td style="vertical-align: top;">D<br>
      </td>
      <td style="vertical-align: top;">E<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
    </tr>
  </tbody><big></big>
</table>
<p class="MsoNormal"><big><br>
<br>
</big></p>
<p class="MsoNormal"><big>Quindi istante di completamento (a partire
dal
tempo zero):</big></p>
<p class="MsoNormal"><big><br>
Job A: 86&nbsp;</big></p>
<p class="MsoNormal"><big>Job B: 61</big></p>
<p class="MsoNormal"><big>Job C: 109</big></p>
<p class="MsoNormal"><big>Job D: 99</big></p>
<p class="MsoNormal"><big>Job E: 104<br>
</big></p>
<hr style="width: 100%; height: 2px;">
<p class="MsoNormal"><big><span style="font-weight: bold;">Esercizio 3</span><br>
<br>
Supponiamo di
ricevere 5 job (A,B,C,D,E)&nbsp; tali che:<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
job&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; Tempo
stimato &nbsp;&nbsp;&nbsp; Tempo di arrivo&nbsp;&nbsp;&nbsp;
Priorita<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;
&nbsp;&nbsp;&nbsp;
A&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
8&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
0&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
2<br>
</big></p>
<p class="MsoNormal"><big>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
B&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
3<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
C&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
3&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
2<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
D&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
3&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
2<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
E&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
3&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
2</big></p>
<div
 style="border-style: solid none none; border-color: windowtext -moz-use-text-color -moz-use-text-color; border-width: 0.5pt medium medium; padding: 1pt 0cm 0cm;">
<p class="MsoNormal"><big><big>Descrivere la sequenza di esecuzione dei
job in
CPU (ad es. tramite Gantt chart) e calcolare l'istante&nbsp;</big></big></p>
<p class="MsoNormal"><big><big>in cui ogni job completa il suo task e
il
relativo tempo totale di completamento ottenuto con:</big></big></p>
<p class="MsoNormal"><big>&nbsp;</big></p>
<p class="MsoNormal"><big> Scheduling a <span
 style="font-weight: bold;">code multiple di priorita' e feedback</span>
dove ogni coda e' gestita con la <span style="font-weight: bold;">strategia
FCFS</span>.<br>
Il <span style="font-weight: bold;">feedback</span> &egrave; definito
come segue: la priorit&agrave; diminuisce di 1 (fino al
livello base 1) se si passano pi&ugrave; di&nbsp; 6 unit&agrave; di
tempo
(consecutive)</big></p>
<p class="MsoNormal"><big>&nbsp;in CPU ed aumenta di 1 per ogni 6
unit&agrave; di tempo passate in attesa in una qualsiasi coda.</big></p>
<p class="MsoNormal"><big>&nbsp;</big></p>
<p class="MsoNormal" style="font-weight: bold;"><big>Soluzione<br>
</big></p>
<p class="MsoNormal" style="font-weight: bold;"><big><br>
</big></p>
<p class="MsoNormal" style="font-weight: bold;"><big><br>
</big></p>
<p class="MsoNormal"><big>Lo scheduler controlla le code (prelaziona la
CPu
se necessario) ogni unita' di tempo<br>
Utilizzamo un Gantt chart: </big><br>
<br>
</p>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">Tempo (*)<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">0<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">2<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">6<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">8<br>
      </td>
      <td style="vertical-align: top;">9<br>
      </td>
      <td style="vertical-align: top;">10<br>
      </td>
      <td style="vertical-align: top;">11<br>
      </td>
      <td style="vertical-align: top;">12<br>
      </td>
      <td style="vertical-align: top;">13<br>
      </td>
      <td style="vertical-align: top;">14<br>
      </td>
      <td style="vertical-align: top;">15<br>
      </td>
      <td style="vertical-align: top;">16<br>
      </td>
      <td style="vertical-align: top;">17<br>
      </td>
      <td style="vertical-align: top;">18<br>
      </td>
      <td style="vertical-align: top;">19<br>
      </td>
      <td style="vertical-align: top;">20<br>
      </td>
      <td style="vertical-align: top;">21<br>
      </td>
      <td style="vertical-align: top;">22<br>
      </td>
      <td style="vertical-align: top;">23</td>
      <td style="vertical-align: top;">24<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;" rowspan="5" colspan="1"><br>
      <br>
Stato dei Job<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);"
 rowspan="1" colspan="1">2<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 255, 0);"
 colspan="6" rowspan="1"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);"
 rowspan="1" colspan="6">3<br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="6">2<br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="4">3<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);">3<br>
      </td>
      <td style="vertical-align: top; background-color: rgb(0, 0, 153);"><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">B<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 255, 0);"><br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);"
 rowspan="1" colspan="6">3<br>
      </td>
      <td style="vertical-align: top; background-color: rgb(0, 0, 153);"
 rowspan="1" colspan="18"><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">C<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 255, 0);"
 rowspan="1" colspan="2"><br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="6">2<br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="5">3<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);"
 colspan="2" rowspan="1">3<br>
      </td>
      <td style="vertical-align: top;" colspan="5" rowspan="1">3<br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="2">4<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);">4<br>
      </td>
      <td style="vertical-align: top; background-color: rgb(0, 0, 153);"
 rowspan="1" colspan="2"><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">D<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 255, 0);"
 rowspan="1" colspan="3"><br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="6">2<br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="6">3<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);"
 rowspan="1" colspan="4">4<br>
      </td>
      <td style="vertical-align: top; background-color: rgb(0, 0, 153);"
 rowspan="1" colspan="6"><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">E<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 255, 0);"
 rowspan="1" colspan="4"><br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="6">2<br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="6">3<br>
      </td>
      <td style="vertical-align: top;" rowspan="1" colspan="3">4<br>
      </td>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);"
 colspan="3" rowspan="1">4<br>
      </td>
      <td style="vertical-align: top; background-color: rgb(0, 0, 153);"
 rowspan="1" colspan="3"><br>
      </td>
    </tr>
  </tbody>
</table>
<p class="MsoNormal"><br>
<big>Istante di completamento:<br>
</big></p>
<p class="MsoNormal"><big>A 24<br>
B 7<br>
C 23<br>
D 19<br>
E 22</big><br>
</p>
<p class="MsoNormal"><br>
</p>
<span style="font-weight: bold;">Nota:</span><br
 style="font-weight: bold;">
&nbsp;La preemption avviene al tempo 13: C sostituisce A; e al tempo
15: D sostituisce C; <br>
&nbsp;Al tempo 19: la coda di priorita 4 ha E in testa e C in coda (C
entra nella coda dopo E)<br>
<br>
<span style="font-weight: bold;">Legenda:</span><br
 style="font-weight: bold;">
<br>
(*)&nbsp; N indica l'intervallo [N,N+1] (ogni casella = 1 unita di
tempo)<br>
<br>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 400px;">
  <tbody>
    <tr>
      <td
 style="vertical-align: top; background-color: rgb(255, 255, 102);"><br>
      </td>
      <td style="vertical-align: top;">Non presente<br>
      </td>
    </tr>
    <tr>
      <td
 style="vertical-align: top; background-color: rgb(255, 102, 0);">N<br>
      </td>
      <td style="vertical-align: top;">Esecuzione in CPU (con priorita
N)<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">N <br>
      </td>
      <td style="vertical-align: top;">Attesa nella coda a priorita N<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top; background-color: rgb(0, 0, 153);"><br>
      </td>
      <td style="vertical-align: top;">Completato<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
<p class="MsoNormal">&nbsp;<br>
</p>
</div>
<p><br clear="all" style="page-break-before: always;">
</p>
<p class="MsoNormal"><!--[if !supportEmptyParas]-->&nbsp;<o:p></o:p><!--[endif]--></p>
</div>
</body>
</html>
